-- GLOBALS: DotHaste_Saved

local isDebug
--@alpha@
isDebug = true
--@end-alpha@
local dots = {
    ["PRIEST"] = {
        [3] = {
            [589] = true, -- shadow word: pain
            --[15407] = true, -- mind flay
            [34914] = true, -- vampiric touch
            --[2944] = true, -- devouring plague
        },
    },
    ["DRUID"] = {
        [1] = {
            [8921] = true, -- moonfire
            [93402] = true, -- sunfire
        },
    },
    ["MAGE"] = {
        [2] = {
            [44457] = true, -- LB
            [11366] = true, -- pyroblast
            [83853] = true, -- combust
        },
    },
    ["WARLOCK"] = {
        [1] = {
            [30108] = true, -- UA
            [172] = true, -- corr
            [980] = true, -- agony
        },
        [2] = {
            [172] = true, -- corr
            [105174] = true, -- hand of gul'dan
            [603] = true, -- doom
        },
        [3] = {
            [348] = true, -- immo
        },
    },
    ["SHAMAN"] = {
        [1] = {
            [8050] = true, -- flame shock
        },
    },
}
local mappedSpellIDs = {
    --[93402] = 8921, -- sunfire to moonfire
}
local dotBreakpoints = {
    -- Info taken from:
    -- https://docs.google.com/spreadsheet/ccc?key=0AsDL8HE-bGDVdFFVWlIzbzQ5RFJJZGFyQ25xZmFYa0E#gid=35
    ["PRIEST"] = {
        [589] = { -- Shadow Word: Pain
            8.322806,
            24.973969,
            41.676512,
            58.353136,
            74.978138,
            91.632079,
            108.405711,
            124.971895,
        },
        [15407] = { -- Mind Flay
            16.66666667,
            50,
            83.33333333,
            116.66666667,
        },
        [34914] = { -- Vampiric Touch
            9.990838,
            30.010840,
            49.962517,
            70.019845,
            90.053861,
            110.010515,
            129.973187,
            150.104231,
        },
        [2944] = { -- Devouring Plague
            6.25111,
            18.741346,
            31.262312,
            43.781459,
            56.290709,
            68.776381,
            81.214146,
            93.735886,
            106.256460,
            118.738623,
        },
    },
    ["DRUID"] = {
        [8921] = { -- Moonfire
            7.152430,
            21.396062,
            35.731261,
            49.981264,
            64.271061,
            78.651200,
            92.771103,
            107.146578,
            121.361397,
            135.710104,
        },
        [93402] = { -- Sunfire
            7.152430,
            21.396062,
            35.731261,
            49.981264,
            64.271061,
            78.651200,
            92.771103,
            107.146578,
            121.361397,
            135.710104,
        },
    },
    ["MAGE"] = {
        [44457] = { -- Living Bomb
            12.507036,
            37.520061,
            62.469546,
            87.441436,
            112.539866,
            137.435713,
        },
        [11366] = { -- Pyroblast
            8.322806,
            24.973969,
            41.676512,
            58.353136,
            74.978138,
            91.632079,
            108.405711,
            124.971895,
            141.643193,
            158.286720,
        },
        [83853] = { -- Combustion
            4.986888,
            15.008639,
            25.078190,
            35.043908,
            45.032653,
            54.918692,
            64.880489,
            74.978158,
            85.013910,
            95.121989,
            105.128247,
            114.822817,
            124.971929,
            135.017682,
        },
    },
    ["WARLOCK"] = {
        [30108] = { -- Unstable Affliction
            0.7152430,
            21.396062,
            35.731261,
            49.981264,
            64.271061,
            78.651200,
            92.771103,
            107.146578,
            121.361397,
            135.710104,
            149.843879,
        },
        [172] = { -- Corruption
            5.568757,
            16.652092,
            27.754719,
            38.937141,
            49.981264,
            61.095462,
            72.191147,
            83.402126,
            94.457967,
            105.655548,
            116.567430,
        },
        [603] = { -- Doom
            12.4957814,
            37.4936983,
            62.4911985,
            87.4882822,
            112.484949,
            137.481199,
            162.477033,
            187.472451,
            212.532562,
            237.495789,
            
        },
        [348] = { -- Immolate
            9.990838,
            30.010840,
            49.962517,
            70.019845,
            90.053861,
            110.010515,
            129.973187,
            150.104231,
        },
        [980] = { -- Agony
            4.193806,
            12.517587,
            20.809430,
            29.157257,
            37.504306,
            45.825749,
            54.142594,
            62.535568,
            70.867165,
            79.131230,
            87.529319,
            95.790523,
        },
        [47960] = { -- Shadowflame (Hand of Gul'Dan)
            8.283715,
            24.921939,
            41.743464,
            58.353153,
            74.978158,
            91.754591,
            108.550617,
            124.971929,
            141.838027,
            158.064583,
        },
    },
    ["SHAMAN"] = {
        [8050] = { -- Flame Shock
            4.986880,
            15.008630,
            25.026052,
            34.983133,
            45.032639,
            54.998716,
            64.971139,
            74.978138,
            85.013887,
            94.995138,
        },
    },
}
local buffModPresets = {
    [31876] = 1.03, -- communion

    [15473] = 1.15, -- shadowform
    [123254] = 1.15,-- Twist of Fate

    [24858] = 1.10, -- moonkin form
    [124974] = 1.20, --  Nature's Vigil
    [112071] = 1.36, -- Celestial Alignment
    [48517] = "if (spellID == 93402) then\n    return (value1/100)+1\nelse\n    return 1\nend", -- solar eclipse
    [48518] = "if (spellID == 8921) then\n    return (value1/100)+1\nelse\n    return 1\nend", -- lunar eclipse
    
    -- Encounters
    [117870] = 1.50, -- Elegon: Touch of the Titans
    [138002] = 1.40, -- Jin'rokh: Fluidity
    
    -- Removed spells
    -- [87153] = "return (spellID == 15407) and ((value1/100)+1) or 1", -- archangel
    -- [94311] = 1.01, -- DI target buff
    -- [94310] = 1.03, -- DI warlock buff
    -- [87118] = 1.02, -- ID UNCONFIRMED evangelism
    -- [48421] = "return (value1/100)+1", -- master shapeshifter: moonkin
    -- [75447] = 1.03, -- ferocious inspiration
    -- [95799] = "return (value1/100)+1", -- empowered shadows (priest mastery)
    -- [82930] = 1.03, -- arcane tactics
}
local _,class = UnitClass("player")
local dotMasterTable = dots[class]
if not dotMasterTable then
    print("<dothaste> Your class is not yet supported. Load aborted.")
    return
end
local pairs, next, ipairs, select, tonumber, _G, tinsert, tremove, tContains, table, math, print, loadstring, type, unpack =
      pairs, next, ipairs, select, tonumber, _G, tinsert, tremove, tContains, table, math, print, loadstring, type, unpack
local GetSpellBonusDamage, MAX_SPELL_SCHOOLS, GetSpellInfo, CreateFrame, UnitExists, UnitCanAttack, UnitGUID, UnitIsUnit, UnitSpellHaste, UnitClass, GetSpecialization, UnitBuff, CLASS_ICON_TCOORDS, ShowUIPanel, ItemRefTooltip, UIParent, GetSpellLink = 
      GetSpellBonusDamage, MAX_SPELL_SCHOOLS, GetSpellInfo, CreateFrame, UnitExists, UnitCanAttack, UnitGUID, UnitIsUnit, UnitSpellHaste, UnitClass, GetSpecialization, UnitBuff, CLASS_ICON_TCOORDS, ShowUIPanel, ItemRefTooltip, UIParent, GetSpellLink
local loadCache = {}
local loadstring_c = function(str)
    if loadCache[str] then return loadCache[str] end
    local func, err = loadstring(("return function(spellID,count,value1,value2,value3)\n%s\nend"):format(str))
    if func then
        loadCache[str] = func()
    end
    return loadCache[str], err
end
local linkcache = {}
local function link(spellID)
    if linkcache[spellID] then
        return linkcache[spellID]
    end
    linkcache[spellID] = GetSpellLink(spellID)
    return linkcache[spellID] or ("#%d"):format(spellID)
end
local dotDataSp = {}
local dotDataHaste = {}
local dotDataBreakpoint = {}
local dotDataApplied = {}
local dotTable
local talentupdate
local display = CreateFrame("Frame","DoTHasteFrame",UIParent)
display.hideFlags = {}
function display:UpdateVisible()
    for _,flag in pairs(self.hideFlags) do
        if flag then
            self:Hide()
            return false
        end
    end
    self:Show()
    return true
end
display:SetMovable(true)
function display:UpdateAnchor()
    self:SetPoint(self.saved.p,self.saved.n and _G[self.saved.n],self.saved.r,self.saved.x,self.saved.y)
end
display.mover = CreateFrame("Frame",nil,UIParent)
display.mover:SetFrameLevel(display:GetFrameLevel()+1)
display.mover:SetAllPoints(display)
display.mover:SetScript("OnMouseDown",function() display:StartMoving() end)
display.mover:SetScript("OnMouseUp",function() display:StopMovingOrSizing() local s,n = display.saved s.p,n,s.r,s.x,s.y = display:GetPoint() s.n = n and n:GetName() end)
display.mover:EnableMouse(true)
display.mover.tex = display.mover:CreateTexture()
display.mover.tex:SetAllPoints()
display.mover.tex:SetAlpha(0.5)
display.mover.tex:SetTexture(0.5,0.5,0.8)
display.mover.lab = display.mover:CreateFontString()
display.mover.lab:SetPoint("CENTER")
display.mover.lab:SetFont("Fonts\\FRIZQT__.TTF", 12, "OUTLINE")
display.mover.lab:SetText("DotHaste:\n- Drag to move\n- /dothaste lock")
function display:UpdateLock()
    self.mover[self.saved.lock and "Hide" or "Show"](self.mover)
end
local function spelldamage(spID)
    local minDmg = GetSpellBonusDamage(2)
    for school=3,MAX_SPELL_SCHOOLS do
        local dmg = GetSpellBonusDamage(school)
        if dmg < minDmg then
            minDmg = dmg
        end
    end
    --print(minDmg)
    local buffCount=1
    local debuffs=false
    local _,_,_,count,_,_,_,_,_,_,buffID,_,_,_,value1,value2,value3 = UnitBuff("player",buffCount)
    if not buffID then
        _,_,_,count,_,_,_,_,_,_,buffID,_,_,_,value1,value2,value3 = UnitDebuff("player",buffCount)
        debuffs = true
    end
    while buffID do
        local buffMod = display.saved.buffs[buffID]
        if type(buffMod) == "string" then
            local func, err = loadstring_c(buffMod)
            if not func then
                print(("[DotHaste] Dynamic buff modifier error for #%d: %s"):format(buffID,err))
            else
                buffMod = func(spID,count,value1,value2,value3)
            end
        end
        if type(buffMod) == "number" then
            --print(buffID,buffMod)
            if count > 1 then
                buffMod = 1+(buffMod-1)*count
                --print(count,buffMod)
            end
            minDmg = minDmg*buffMod
        end
        buffCount = buffCount+1
        if debuffs then
            _,_,_,count,_,_,_,_,_,_,buffID,_,_,_,value1,value2,value3 = UnitDebuff("player",buffCount)
        else
            _,_,_,count,_,_,_,_,_,_,buffID,_,_,_,value1,value2,value3 = UnitBuff("player",buffCount)
            if not buffID then
                buffCount = 1
                _,_,_,count,_,_,_,_,_,_,buffID,_,_,_,value1,value2,value3 = UnitDebuff("player",buffCount)
                debuffs = true
            end
        end
    end
    --print(minDmg)
    return tonumber(("%.0f"):format(minDmg))
end
local slashKeyCache = {}
local slashTable = {
    lock={
        type="handler",
        handler=function()
            display.saved.lock = not display.saved.lock
            display:UpdateLock()
        end,
    },
    scale={
        type="handler",
        handler=function(_,n)
            n = tonumber(n)
            if n then
                display:SetScale(n*0.5)
                display.saved.s = n
            end
        end,
    },
    showdiff={
        type="handler",
        handler=function()
            display.saved.showDiff = not display.saved.showDiff
            talentupdate(true)
        end,
    },
    owntexture={
        type="handler",
        handler=function(_,n)
            if n and (not n:find("^%s*$")) then
                display.saved.overrideOwnTexture = n
                if display.saved.showDiff then
                    display.bars[1].icon:SetTexture(display.saved.overrideOwnTexture)
                    display.bars[1].icon:SetTexCoord(0,1,0,1)
                end
            else
                display.saved.overrideOwnTexture = nil
                if display.saved.showDiff then
                    display.bars[1].icon:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes")
                    display.bars[1].icon:SetTexCoord(unpack(CLASS_ICON_TCOORDS[(select(2,UnitClass("player")))]))
                end
            end
        end,
    },
    missingtext={
        type="handler",
        handler=function(_,n)
            if n and (not n:find("^%s*$")) then
                display.saved.missingText = n
            else
                display.saved.missingText = nil
            end
            display:Update()
        end,
    },
    nudge = {
        type="group",
        args={
            up = {
                type="handler",
                handler=function(_,n)
                    n = tonumber(n)
                    if n then
                        display.saved.y = display.saved.y+n
                        display:UpdateAnchor()
                    end
                end,
            },
            down = {
                type = "handler",
                handler=function(_,n)
                    n = tonumber(n)
                    if n then
                        display.saved.y = display.saved.y-n
                        display:UpdateAnchor()
                    end
                end,
            },
            left = {
                type = "handler",
                handler=function(_,n)
                    n = tonumber(n)
                    if n then
                        display.saved.x = display.saved.x-n
                        display:UpdateAnchor()
                    end
                end,
            },
            right = {
                type = "handler",
                handler = function(_,n)
                    n = tonumber(n)
                    if n then
                        display.saved.x = display.saved.x+n
                        display:UpdateAnchor()
                    end
                end,
            },
        },
    },
    breakpoints={
        type = "group",
        handler = function(command, arg)
            local spell, sub = command:match("(%S+) (%S+)$")
            spell = slashKeyCache[spell]
            arg = tonumber(arg)
            arg = arg and tonumber(("%.2f"):format(arg))
            if sub == "add" then
                if not arg then
                    print("Proper usage: /dh",command," <percentage>")
                    return
                end
                if not display.saved.breakpoints[spell] then
                    display.saved.breakpoints[spell] = {}
                end
                if tContains(display.saved.breakpoints[spell],arg) then
                    print("Already defined breakpoint:",arg,"%")
                else
                    tinsert(display.saved.breakpoints[spell],arg)
                    table.sort(display.saved.breakpoints[spell])
                    print("Added:",arg,"%")
                end
            elseif sub == "list" then
                print("Breakpoints for",link(spell))
                for num,pct in ipairs(display.saved.breakpoints[spell] or {}) do
                    print(("%d: %.2f%%"):format(num,pct))
                end
            elseif sub == "reset" then
                display.saved.breakpoints[spell] = (dotBreakpoints[(select(2,UnitClass("player")))] or {})[spell] or {}
                print("Breakpoints reset for",link(spell))
            elseif sub == "delete" then
                if not arg then
                    print("Proper usage: /dh",command," <percentage>")
                    return
                end
                for key,num in ipairs(display.saved.breakpoints[spell] or {}) do
                    if num == arg then
                        tremove(display.saved.breakpoints[spell],key)
                        print("Removed:",arg,"%")
                        return
                    end
                end
                print("Breakpoint not found:",arg,"%")
            end
        end,
        args={},
    },
    buff={
        type = "group",
        args = {
            add={
                type = "handler",
                handler = function(_,args)
                    local spellID, percent = args:match("^(%d+) (%d*.?%d*)$")
                    spellID, percent = tonumber(spellID),tonumber(percent)
                    if spellID and percent then
                        percent = percent/100
                        display.saved.buffs[spellID] = percent+1
                        print(("Added: %s - %f%%"):format(link(spellID),percent*100))
                    else
                        local spellName, percent = args:match("^\"(.+)\" (%d*.?%d*)$")
                        percent = tonumber(percent)
                        if percent then
                            percent = percent/100
                            local _,_,_,_,_,_,_,_,_,_,buffID = UnitBuff("player",spellName)
                            if buffID then
                                display.saved.buffs[buffID] = percent+1
                                print(("Added: %s (%d) - %f%%"):format(spellName,buffID,percent*100))
                                return
                            end
                        end
                        print("Proper usage: /dh buff add <spellID> <addedPercent>")
                    end
                end,
            },
            list={
                type = "handler",
                handler = function()
                    print("Buff damage modifiers:")
                    for spellID,percentage in pairs(display.saved.buffs) do
                        if type(percentage) == "number" then
                            print(("%s: %f%%"):format(link(spellID),(percentage-1)*100))
                        else
                            print(("%s: |cffffaa00|Hdothastedynbuff:%s|h[DYNAMIC]|h|r"):format(link(spellID),percentage))
                        end
                    end
                end,
            },
            reset={
                type = "handler",
                handler = function()
                    display.saved.buffs = buffModPresets
                    print("Buff modifiers reset to defaults")
                end,
            },
            delete={
                type = "handler",
                handler = function(_,arg)
                    local spellID = tonumber(arg)
                    if spellID then
                        if display.saved.buffs[spellID] then
                            print(("Deleted: %s"):format(link(spellID)))
                            display.saved.buffs[spellID] = nil
                        else
                            print(spellID,"is not a known buff!")
                        end
                    else
                        print("Proper usage: /dh buff delete <spellID>")
                    end
                end,
            },
        },
    },
}
local hadInit
local function init()
    hadInit = true
    display.bars = {}
    function display:Update()
        if not (UnitExists("target") and UnitCanAttack("player","target")) then
            self.hideFlags.target = true
            self:UpdateVisible()
            return
        end
        self.hideFlags.target = nil
        if not self:UpdateVisible() then
            return
        end
        local targetGUID = UnitGUID("target")
        local currentHastePct = UnitSpellHaste("player")
        for _,bar in ipairs(self.bars) do
            if bar:IsShown() then
                local id = bar.spellID
                if id == "cur" then
                    local currentSP = spelldamage()
                    bar.spLabel:SetTextColor(1,1,1)
                    bar.spLabel:SetText(currentSP)
                    bar.hasteLabel:SetTextColor(1,1,1)
                    bar.hasteLabel:SetText(("%.2f%%"):format(currentHastePct))
                else
                    local appliedID = dotDataApplied[id][targetGUID]
                    local currentSP = spelldamage(appliedID)
                    local sp, haste, nextBreak = dotDataSp[id][targetGUID], dotDataHaste[id][targetGUID], dotDataBreakpoint[id][targetGUID]
                    if sp and (sp > currentSP) then
                        bar.spLabel:SetTextColor(0.4,0.4,1)
                        bar.spLabel:SetText(sp)
                    elseif sp == currentSP then
                        bar.spLabel:SetTextColor(0.4,1,0.4)
                        bar.spLabel:SetText(currentSP)
                    elseif sp then
                        bar.spLabel:SetTextColor(1,1,0.4)
                        bar.spLabel:SetText(currentSP)
                    else
                        bar.spLabel:SetText(display.saved.missingText)
                    end
                    if sp and self.saved.showDiff then
                        local diff = currentSP-sp
                        if diff == 0 then
                            bar.spLabel:SetText("-")
                        else
                            bar.spLabel:SetText(("%+d"):format(diff))
                        end
                    end
                    if nextBreak and (currentHastePct > nextBreak) then
                        bar.hasteLabel:SetTextColor(1,0.4,0.4)
                        bar.spLabel:SetTextColor(1,0.4,0.4)
                        bar.hasteLabel:SetText(("%.2f%%"):format(currentHastePct))
                    elseif haste and (haste < currentHastePct) then
                        bar.hasteLabel:SetTextColor(1,1,0.4)
                        bar.hasteLabel:SetText(("%.2f%%"):format(currentHastePct))
                    elseif haste == currentHastePct then
                        bar.hasteLabel:SetTextColor(0.4,1,0.4)
                        bar.hasteLabel:SetText(("%.2f%%"):format(currentHastePct))
                    elseif haste then
                        bar.hasteLabel:SetTextColor(0.4,0.4,1)
                        bar.hasteLabel:SetText(("%.2f%%"):format(haste))
                    else
                        bar.hasteLabel:SetText()
                    end
                    if haste and self.saved.showDiff then
                        local diff = currentHastePct-haste
                        if diff == 0 then
                            bar.hasteLabel:SetText("-")
                        else
                            bar.hasteLabel:SetText(("%+.2f%%"):format(diff))
                        end
                    end
                end
            end
        end
    end
    display:Update()
    if dotTable then
        display:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    end
    display:RegisterEvent("UNIT_SPELL_HASTE")
    display:RegisterEvent("UNIT_AURA")
    display:RegisterEvent("COMBAT_RATING_UPDATE")
    display:RegisterEvent("PLAYER_DAMAGE_DONE_MODS")
    display:RegisterEvent("PLAYER_TARGET_CHANGED")
    display:RegisterEvent("UNIT_DYNAMIC_FLAGS")
    display:RegisterEvent("UNIT_FLAGS")
    display:RegisterEvent("UNIT_FACTION")
    display:RegisterEvent("UNIT_TARGETABLE_CHANGED")
end
local slashSubTable = {
    type="group",
    args={
        add={
            type="handler",
        },
        list={
            type="handler",
        },
        delete={
            type="handler",
        },
    },
}
talentupdate = function(noAnnounceNF)
    noAnnounceNF = noAnnounceNF and (not isDebug)
    local currentSpec = GetSpecialization()
    if not currentSpec then
        if not noAnnounceNF then
            print("<dothaste> Talents not found! Delaying load!")
        end
        return
    end
    dotTable = dotMasterTable[currentSpec]
    if not dotTable then
        if not display.hideFlags.spec then
            if not noAnnounceNF then
                print("<dothaste> Your current spec is not supported by DotHaste. Hiding display.")
            end
            display.hideFlags.spec = true
            display:UpdateVisible()
        end
        display:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
        return
    end
    display:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
    display.hideFlags.spec = nil
    display:UpdateVisible()
    local keyCount = 0
    table.wipe(slashTable.breakpoints.args)
    for key in pairs(dotTable) do
        local name,_,icon = GetSpellInfo(key)
        if not icon then
            if not noAnnounceNF then
                print(("<dothaste> No icon found for ID %d. Waiting for SPELLS_CHANGED."):format(key))
            end
            display:RegisterEvent("SPELLS_CHANGED")
            return
        else
            dotDataSp[key] = dotDataSp[key] or {}
            dotDataHaste[key] = dotDataHaste[key] or {}
            dotDataBreakpoint[key] = dotDataBreakpoint[key] or {}
            dotDataApplied[key] = dotDataApplied[key] or {}
            dotTable[key] = icon
            name = name:gsub("[^a-zA-Z]",""):lower()
            slashTable.breakpoints.args[name] = slashSubTable
            slashKeyCache[name] = key
            keyCount = keyCount+1
        end
    end
    for key,val in pairs(mappedSpellIDs) do
        local name = GetSpellInfo(key)
        if not name then
            if not noAnnounceNF then
                print(("<dothaste> No spell name found for ID %d. Waiting for SPELLS_CHANGED."):format(key))
            end
            display:RegisterEvent("SPELLS_CHANGED")
            return
        else
            name = name:gsub("[^a-zA-Z]",""):lower()
            slashTable.breakpoints.args[name] = slashSubTable
            if dotBreakpoints[key] then -- if it has its own dotBreakpoints entry, it has own breakpoints too (agony <-> doom)
                slashKeyCache[name] = key
            else
                slashKeyCache[name] = val
            end
        end
    end
    if display.saved.showDiff then keyCount = keyCount+1 end -- current display
    display:SetSize(250,50*keyCount)
    if not hadInit then init() end
    local lastKey
    for num=1,keyCount do
        local displayBar = display.bars[num]
        if not displayBar then
            displayBar = CreateFrame("Frame",nil,display)
            displayBar:SetSize(250,50)
            displayBar:SetPoint("TOPLEFT",0,-50*(num-1))
            displayBar.icon = displayBar:CreateTexture()
            displayBar.icon:SetPoint("TOPLEFT")
            displayBar.icon:SetSize(50,50)
            displayBar.spLabel = displayBar:CreateFontString()
            displayBar.spLabel:SetFont("Fonts\\FRIZQT__.TTF", 18, "OUTLINE")
            displayBar.spLabel:SetPoint("TOPLEFT",50,0)
            displayBar.spLabel:SetPoint("BOTTOMRIGHT",displayBar,"BOTTOMLEFT",150,0)
            displayBar.hasteLabel = displayBar:CreateFontString()
            displayBar.hasteLabel:SetFont("Fonts\\FRIZQT__.TTF", 18, "OUTLINE")
            displayBar.hasteLabel:SetPoint("TOPLEFT",150,0)
            displayBar.hasteLabel:SetPoint("BOTTOMRIGHT")
            display.bars[num] = displayBar
        else
            displayBar:Show()
        end
        if display.saved.showDiff and (num == 1) then
            if display.saved.overrideOwnTexture then
                displayBar.icon:SetTexture(display.saved.overrideOwnTexture)
                displayBar.icon:SetTexCoord(0,1,0,1)
            else
                displayBar.icon:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes")
                displayBar.icon:SetTexCoord(unpack(CLASS_ICON_TCOORDS[(select(2,UnitClass("player")))]))
            end
            displayBar.spellID = "cur"
        else
            displayBar.icon:SetTexCoord(0,1,0,1)
            local key, tex = next(dotTable,lastKey)
            displayBar.icon:SetTexture(tex)
            displayBar.spellID = key
            lastKey = key
        end
    end
    for num=keyCount+1,#display.bars do
        display.bars[num]:Hide()
    end
end
display:SetScript("OnEvent", function(self,event,...)
    self.pguid = self.pguid or UnitGUID("player")
    if event == "SPELLS_CHANGED" then
        self:UnregisterEvent("SPELLS_CHANGED")
        init()
    elseif (event == "ADDON_LOADED") and ((...) == "DotHaste") then
        DotHaste_Saved = DotHaste_Saved or {p="CENTER",r="CENTER",n="UIParent",x=0,y=0,s=1,lock=false,}
        self.saved = DotHaste_Saved
        display:SetScale(self.saved.s*0.5)
        display:UpdateAnchor()
        display:UpdateLock()
        self.saved.breakpoints = self.saved.breakpoints or {}
        for key, breakpoints in pairs(dotBreakpoints[(select(2,UnitClass("player")))] or {}) do
            self.saved.breakpoints[key] = self.saved.breakpoints[key] or breakpoints
        end
        self.saved.buffs = self.saved.buffs or buffModPresets
        self:UnregisterEvent("ADDON_LOADED")
        talentupdate(true)
    elseif (event == "COMBAT_LOG_EVENT_UNFILTERED") then
        if select(4,...) == self.pguid then
            local subEvent = select(2,...)
            if (subEvent == "SPELL_AURA_APPLIED") or (subEvent == "SPELL_AURA_REFRESH") then
                local pureID = select(12,...)
                local spellID = mappedSpellIDs[pureID] or pureID
                if dotTable[spellID] then
                    local sp, hastePct = spelldamage(pureID), UnitSpellHaste("player")
                    local nextBreakpoint = math.huge
                    for _,value in ipairs(self.saved.breakpoints[pureID] or self.saved.breakpoints[spellID] or {}) do
                        if value > hastePct then
                            nextBreakpoint = value
                            break
                        end
                    end
                    local targetGUID = select(8,...)
                    dotDataSp[spellID][targetGUID] = sp
                    dotDataHaste[spellID][targetGUID] = hastePct
                    dotDataBreakpoint[spellID][targetGUID] = nextBreakpoint
                    dotDataApplied[spellID][targetGUID] = pureID
                    display:Update()
                end
            elseif (subEvent == "SPELL_AURA_REMOVED") then
                local spellID = select(12,...)
                spellID = mappedSpellIDs[spellID] or spellID
                if dotTable[spellID] then
                    local dstGUID = select(8,...)
                    dotDataSp[spellID][dstGUID] = nil
                    dotDataHaste[spellID][dstGUID] = nil
                    dotDataBreakpoint[spellID][dstGUID] = nil
                    dotDataApplied[spellID][dstGUID] = nil
                    display:Update()
                end
            end
        end
    elseif ((event == "UNIT_AURA") or (event == "UNIT_SPELL_HASTE")) and UnitIsUnit((...),"player") then
        display:Update()    
    elseif (event == "PLAYER_SPECIALIZATION_CHANGED") or (event == "ACTIVE_TALENT_GROUP_CHANGED") then
        talentupdate()
    else
        display:Update()
    end
end)
display:RegisterEvent("ADDON_LOADED")
display:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
display:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
LibStub("LibShorterSlash-1.0"):RegisterCommand(slashTable,"/dothaste","/dh")
-- GLOBALS: ChatFrame_OnHyperlinkShow
local orig_ChatFrame_OnHyperlinkShow = ChatFrame_OnHyperlinkShow
function ChatFrame_OnHyperlinkShow(...)
    local linkString = select(2,...)
    local funcCode = linkString:match("^dothastedynbuff:(.+)$")
    if funcCode then
        ShowUIPanel(ItemRefTooltip)
        if not ItemRefTooltip:IsShown() then
            ItemRefTooltip:SetOwner(UIParent, "ANCHOR_PRESERVE")
        end
        ItemRefTooltip:ClearLines()
        ItemRefTooltip:AddLine("Variable buff modifier:",1,0.82,0)
        ItemRefTooltip:AddLine(funcCode,1,1,1)
        ItemRefTooltip:Show()
    else
        orig_ChatFrame_OnHyperlinkShow(...)
    end
end